package controller

import (
	"fmt"
	"strings"
	"time"

	"be.ems/src/framework/i18n"
	"be.ems/src/framework/utils/ctx"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/vo/result"
	"be.ems/src/modules/network_data/model"
	neDataService "be.ems/src/modules/network_data/service"
	neFetchlink "be.ems/src/modules/network_element/fetch_link"
	neService "be.ems/src/modules/network_element/service"

	"github.com/gin-gonic/gin"
)

// 实例化控制层 AMFController 结构体
var NewAMF = &AMFController{
	neInfoService:  neService.NewNeInfo,
	ueEventService: neDataService.NewUEEventAMF,
}

// 网元AMF
//
// PATH /amf
type AMFController struct {
	neInfoService  *neService.NeInfo         // 网元信息服务
	ueEventService *neDataService.UEEventAMF // UE会话事件服务
}

// UE会话列表
//
// GET /ue/list
//
//	@Tags			network_data/amf
//	@Accept			json
//	@Produce		json
//	@Param			neType		query		string	true	"NE Type only AMF"	Enums(AMF)
//	@Param			neId		query		string	true	"NE ID"				default(001)
//	@Param			imsi		query		string	false	"imsi"
//	@Param			pageNum		query		number	true	"pageNum"	default(1)
//	@Param			pageSize	query		number	true	"pageSize"	default(10)
//	@Success		200			{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		UE Session List
//	@Description	UE Session List
//	@Router			/neData/amf/ue/list [get]
func (s *AMFController) UEList(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	var querys model.UEEventAMFQuery
	if err := c.ShouldBindQuery(&querys); err != nil {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 查询网元获取IP
	neInfo := s.neInfoService.SelectNeInfoByNeTypeAndNeID("AMF", querys.NeID)
	if neInfo.NeId != querys.NeID || neInfo.IP == "" {
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}
	querys.RmUID = neInfo.RmUID

	// 查询数据
	rows, total := s.ueEventService.SelectPage(querys)
	c.JSON(200, result.Ok(map[string]any{"rows": rows, "total": total}))
}

// UE会话删除
//
// DELETE /ue/:ueIds
//
//	@Tags			network_data/amf
//	@Accept			json
//	@Produce		json
//	@Param			ueIds	path		string	true	"list data id, multiple separated by a , sign"
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		UE Session Deletion
//	@Description	UE Session Deletion
//	@Router			/neData/amf/ue/{ueIds} [delete]
func (s *AMFController) UERemove(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	ueIds := c.Param("ueIds")
	if ueIds == "" {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}
	// 处理字符转id数组后去重
	ids := strings.Split(ueIds, ",")
	uniqueIDs := parse.RemoveDuplicates(ids)
	if len(uniqueIDs) <= 0 {
		c.JSON(200, result.Err(nil))
		return
	}
	rows, err := s.ueEventService.DeleteByIds(uniqueIDs)
	if err != nil {
		c.JSON(200, result.ErrMsg(i18n.TKey(language, err.Error())))
		return
	}
	msg := i18n.TTemplate(language, "app.common.deleteSuccess", map[string]any{"num": rows})
	c.JSON(200, result.OkMsg(msg))
}

// UE会话列表导出
//
// POST /ue/export
//
//	@Tags			network_data/amf
//	@Accept			json
//	@Produce		json
//	@Param			data	body		object	true	"Request Param"
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		UE Session List Export
//	@Description	UE Session List Export
//	@Router			/neData/amf/ue/export [post]
func (s *AMFController) UEExport(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	// 查询结果，根据查询条件结果，单页最大值限制
	var querys model.UEEventAMFQuery
	if err := c.ShouldBindBodyWithJSON(&querys); err != nil {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}
	// 限制导出数据集
	if querys.PageSize > 10000 {
		querys.PageSize = 10000
	}
	// 查询网元获取IP
	neInfo := s.neInfoService.SelectNeInfoByNeTypeAndNeID("AMF", querys.NeID)
	if neInfo.NeId != querys.NeID || neInfo.IP == "" {
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}
	querys.RmUID = neInfo.RmUID
	rows, total := s.ueEventService.SelectPage(querys)
	if total == 0 {
		// 导出数据记录为空
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.exportEmpty")))
		return
	}

	// 导出文件名称
	fileName := fmt.Sprintf("amf_ue_event_export_%d_%d.xlsx", len(rows), time.Now().UnixMilli())
	// 导出数据表格
	saveFilePath, err := s.ueEventService.ExportXlsx(rows, fileName, language)
	if err != nil {
		c.JSON(200, result.ErrMsg(err.Error()))
		return
	}

	c.FileAttachment(saveFilePath, fileName)
}

// 接入基站信息列表
//
// GET /nb/list
//
//	@Tags			network_data/amf
//	@Accept			json
//	@Produce		json
//	@Param			neId	query		string	true	"NE ID"	default(001)
//	@Param			id		query		string	false	"Base Station ID"
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		Access Base Station Information List
//	@Description	Access Base Station Information List
//	@Router			/neData/amf/nb/list [get]
func (s *AMFController) NbInfoList(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	var query struct {
		NeId string `form:"neId" binding:"required"`
		NbId string `form:"id"`
	}
	if err := c.ShouldBindQuery(&query); err != nil {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 查询网元信息
	neInfo := s.neInfoService.SelectNeInfoByNeTypeAndNeID("AMF", query.NeId)
	if neInfo.NeId != query.NeId || neInfo.IP == "" {
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}

	// 网元直连
	data, err := neFetchlink.AMFNbInfoList(neInfo, map[string]string{
		"id": query.NbId,
	})
	if err != nil {
		c.JSON(200, result.ErrMsg(err.Error()))
		return
	}

	c.JSON(200, result.OkData(data))
}

// 接入基站状态信息列表
//
// GET /nb/list-cfg
//
//	@Tags			network_data/amf
//	@Accept			json
//	@Produce		json
//	@Param			neId	query		string	true	"NE ID"	default(001)
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		Access to the base station status information list
//	@Description	Access to the base station status information list
//	@Router			/neData/amf/nb/list-cfg [get]
func (s *AMFController) NbStateList(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	var query struct {
		NeId string `form:"neId" binding:"required"`
	}
	if err := c.ShouldBindQuery(&query); err != nil {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 查询网元信息
	neInfo := s.neInfoService.SelectNeInfoByNeTypeAndNeID("AMF", query.NeId)
	if neInfo.NeId != query.NeId || neInfo.IP == "" {
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}

	// 网元直连
	data, err := neFetchlink.AMFGnbStateList(neInfo)
	if err != nil {
		c.JSON(200, result.ErrMsg(err.Error()))
		return
	}

	c.JSON(200, result.OkData(data))
}
